﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Text;
using OSGeo.MapGuide;

namespace MapGuideSample
{
    public partial class Task : System.Web.UI.Page
    {
        protected void Page_Load(object sender, EventArgs e)
        {

        }

        protected void Button1_Click(object sender, EventArgs e)
        {            
            //string mapName = "Default";
            //string layerName = "Collettore";
            //string queryString = "FID = 19216";
            string mapName = "comuni";
            string layerName = "comuni";
            string queryString = "FeatId = 13";            

            try
            {
                //init MG                
                OSGeo.MapGuide.MapGuideApi.MgInitializeWebTier(@"C:\Program Files\OSGeo\MapGuide\Web\www\webconfig.ini");                
               
                //open connection
                string mapguideSessionId = Request.QueryString.Get("SESSION");
                
                MgSiteConnection siteConnection = new MgSiteConnection();
                MgUserInformation userInfo = new MgUserInformation(mapguideSessionId);
                siteConnection.Open(userInfo);


                MgResourceService resService = (MgResourceService)siteConnection.CreateService(MgServiceType.ResourceService);
                MgFeatureService featureService = (MgFeatureService)siteConnection.CreateService(MgServiceType.FeatureService);

                MgMap map = new MgMap();                
                map.Open(resService, mapName);
                
                //get layer res id
                MgLayer layer = (MgLayer)map.GetLayers().GetItem(layerName);                
                MgResourceIdentifier resId = new MgResourceIdentifier(layer.GetFeatureSourceId());

                //build query option
                MgFeatureQueryOptions queryOption = new MgFeatureQueryOptions();
                queryOption.SetFilter(queryString);

                //get selection
                MgFeatureReader featureReader = featureService.SelectFeatures(resId, layer.GetFeatureClassName(), queryOption);
                MgSelection selection = new MgSelection(map);
                selection.AddFeatures(layer, featureReader, 0);

                //get XML from selection
                string selectionXML = selection.ToXml();

                //get center
                double selectionCenterX = selection.GetExtents(featureService).GetLowerLeftCoordinate().GetX() + selection.GetExtents(featureService).GetWidth() / 2;
                double selectionCenterY = selection.GetExtents(featureService).GetLowerLeftCoordinate().GetY() + selection.GetExtents(featureService).GetHeight() / 2;

                //build javascript
                StringBuilder onLoadJScript = new StringBuilder();
                onLoadJScript.Append("<script type='text/javascript'>                                                                     ");
                onLoadJScript.Append("                                                                                                    ");
                onLoadJScript.Append("        var selectionXML = '" + selectionXML + "';                                                  ");
                onLoadJScript.Append("        var selectionCenterX = " + selectionCenterX.ToString().Replace(",", ".") + ";               ");
                onLoadJScript.Append("        var selectionCenterY = " + selectionCenterY.ToString().Replace(",", ".") + ";               ");
                onLoadJScript.Append("        if(selectionCenterX != 0 && selectionCenterY != 0)                                          ");
                onLoadJScript.Append("        {                                                                                           ");
                onLoadJScript.Append("            parent.parent.SetSelectionXML(selectionXML);                                            ");
                onLoadJScript.Append("            parent.parent.ZoomToView(selectionCenterX, selectionCenterY, 135000, false);               ");
                //onLoadJScript.Append("            alert(selectionXML);                                                                    ");
                onLoadJScript.Append("        }                                                                                           ");
                onLoadJScript.Append("                                                                                                    ");
                onLoadJScript.Append("</script>                                                                                           ");

                //execute javascript
                ClientScript.RegisterStartupScript(this.GetType(), "StartupScript", onLoadJScript.ToString());

            }
            catch (Exception ex)
            {
                Response.Write(ex.Message);
            }
        }
    }
}